import { createCipheriv, createDecipheriv } from 'crypto-browserify'
import { Buffer } from 'buffer/'
class PandaEncrypter {
  #brandId

  constructor(brandId) {
    this.#brandId = brandId
  }

  encrypt(plaintext) {
    const cipher = 'aes-128-ecb'
    const aesKey = this.#makePandaAesKey(this.#brandId)
    const cipherObj = createCipheriv(cipher, aesKey, Buffer.alloc(0))
    let encrypted = cipherObj.update(Buffer.from(plaintext.toString()), 'utf8', 'hex')
    encrypted += cipherObj.final('hex')
    return encrypted
  }

  decrypt(encrypted) {
    let ciphertext = Buffer.from(encrypted, 'hex')
    let cipher = 'aes-128-ecb'
    const decipher = createDecipheriv(
      cipher,
      this.#makePandaAesKey(this.#brandId),
      ''
    )
    let decrypted = decipher.update(ciphertext, null, 'utf8')
    decrypted += decipher.final('utf8')
    return decrypted
  }

  #makePandaAesKey = function (key) {
    let newKey = Array(16).fill('\0')
    for (let i = 0, len = key.length; i < len; i++) {
      newKey[i % 16] = String.fromCharCode(newKey[i % 16].charCodeAt(0) ^ key.charCodeAt(i))
    }
    return newKey.join('')
  }
}

export default PandaEncrypter