import commonjs from '@rollup/plugin-commonjs'
import json from '@rollup/plugin-json'
import { nodeResolve } from '@rollup/plugin-node-resolve';
import nodePolyfills from 'rollup-plugin-polyfill-node'
import { uglify } from 'rollup-plugin-uglify'

export default {
    input: 'main.mjs',
    cache: false,
    output: {
    //   intro: 'var global = window',
      name: 'PandaEncrypter',
      file: 'PandaEncrypter.js',
      format: 'iife',
      sourcemap: false,
      exports: 'default',
      generatedCode: 'es5',
    },
    plugins: [
      nodePolyfills({
        include: ['crypto', 'buffer'],
      }),
      nodeResolve({ preferBuiltins: false }),
      commonjs(),
      json(),
      uglify(),
    ],
  }